<?php
/** 
 * 
 * @author Piotr Kozdęba <piotr.ko@modulesgarden.com>
 */
class OPO_Pages_Index extends OPO_Controller
{
    public function actionIndex()
    {
        return '[No proper action found]';
    }
    
    
    public function actionGetErrorPage()
    {
        //path to template
        $templatepath = MAIN_WHMCS_DIR_.
                        'templates'.DS.
                        'orderforms'.DS.
                        OPO_Configuration_Configuration::$template_name.DS.
                        'error.tpl';
        
        
        $page = new OPO_PageBuilder_PageBuilder($templatepath);
        
        global $_LANG;
        
        $page->LANG         = $_LANG;
        $page->carttpl      = OPO_Configuration_Configuration::$template_name;
        $page->errortitle   = $_LANG['erroroccured'];
        $page->errormsg     = $_LANG['genericerror']['msg']; 
        
        return $page->build();
    }
    
    
    public function actionGetCartProductIdAndDomain()
    {
        //getting id and domain:
        list($pid,$maindomain) = OPO_System_Sessionmanagement::getCartProductIdAndDomain();
        
        return json_encode(array('pid'=>$pid, 'maindomain'=>$maindomain));
    }
    
    public function actionGetCartSuggestedDomains()
    {
        //getting suggested domains from cart:
        $suggesteddomains = OPO_System_Sessionmanagement::getCartSuggestedDomains(); 
        //each has: type,domain,regperiod
        
        return json_encode($suggesteddomains);
    }
    
    
    
    //prepares and generates "Chose Domain" step to be viewable even if there is no product that needs domain in WHMCS
    public function actionGetConfigureProductDomainStartup()
    {
        //path to template
        $templatepath = MAIN_WHMCS_DIR_.
                        'templates'.DS.
                        'orderforms'.DS.
                        OPO_Configuration_Configuration::$template_name.DS.
                        'pregen_configureproductdomain.tpl';
        
        
        $page = new OPO_PageBuilder_PageBuilder($templatepath);
        global $_LANG;
        global $currency;
        
        $whmcs_config = OPO_WHMCS_Configuration::get(array(
            'AllowRegister',
            'AllowOwnDomain',
            'CompanyName'
        ));
     
        if (!$currency)
        {
            $currency = getCurrency($_SESSION['uid']);
        }
        $domain = OPO_System_Sessionmanagement::getCartDomain();
        
        if (trim($domain)=='thisistestdomainonlyandwontberegistered.test') $domain='';
        
        preg_match('/^(.*)(\.[^\.]*)$/',$domain,$matches);
        
        $page->LANG                     = $_LANG;
        $page->registerdomainenabled    = $whmcs_config['AllowRegister'];
        $page->owndomainenabled         = $whmcs_config['AllowOwnDomain']; 
        $page->companyname              = $whmcs_config['CompanyName'];
        $page->sld                      = $matches[1]?$matches[1]:'';
        $page->registertlds             = $tlds = getTLDList();
        $page->tld                      = $matches[2]?$matches[2]:array_shift($tlds);
        
        
         return $page->build();
    }
    
    
    public function actionReconfigureCartToMatchDomains()
    {
        $sessionbefore = $_SESSION;
        $domainstoleave = isset($_POST['domains'])?$_POST['domains']:array();
        $domainmode     = isset($_POST['real_domainoption'])?$_POST['real_domainoption']:
                            (isset($_POST['domainoption'])?$_POST['domainoption']:'register');
        $productdomain  = isset($_POST['maindomain'])?$_POST['maindomain']:''; 
        $mainisunavailable = true;
        if($_POST['real_domainoption'] == 'transfer')
        {
            $_POST['domainoption'] = 'transfer';
        }
        
        //if there is domain typed:
        if ($productdomain)
        {
            $mainisunavailable = false;
            //if the productdomain is in "domains" list (always, but not when domain is not available - there still can be suggestions in that case )
            //remove it from there if this is owndomain (since it shouldn't be in $_SESSION[cart][domains])
            //and mark 'mainisunavailable' flag if productdomain is unavailable (not found in domains list) 
            $exist = false;
            foreach($domainstoleave as $k=>$dom)
            {
                if (trim($dom)==$productdomain) 
                {
                    $exist = true;
                    if ($domainmode == 'owndomain') unset($domainstoleave[$k]);
                }
            }
            if (!$exist) 
                $mainisunavailable = true;
        }
        
        //log results if debug mode is on:
        if (OPO_Configuration_Configuration::$log_errors)
            logModuleCall(
                    OPO_Configuration_Configuration::$module_name,
                    '',
                    'actionReconfigureCartToMatchDomains',
                    '',
                    'DOMAINSTOLEAVE='.PHP_EOL.
                    print_r($domainstoleave,true).PHP_EOL.
                    'PRODUCTDOMAIN='.$productdomain.PHP_EOL.
                    'POST DATA='.PHP_EOL.
                    print_r($_POST,true).PHP_EOL.
                    'DOMAINMODE='.$domainmode
                    );
        
        //reorganize domains to match the request:
        OPO_System_Sessionmanagement::reorganizeCart(true,$domainstoleave,$productdomain,$domainmode,$mainisunavailable);
        
        $sessionafter = $_SESSION;
        
        //log session information if debug mode is on:
        if (OPO_Configuration_Configuration::$log_errors)
            logModuleCall(
                    OPO_Configuration_Configuration::$module_name,
                    '',
                    'actionReconfigureCartToMatchDomains',
                    '',
                    'SESSIONBEFORE='.PHP_EOL.
                    print_r($sessionbefore,true).PHP_EOL.
                    'SESSIONAFTER='.PHP_EOL.
                    print_r($sessionafter,true).PHP_EOL
                    );
        
        //announce success:
        echo 'COMPLETE';
        
    }
    
    
    public function actionGetDomainsConfigForced()
    {
        //path to template
        $templatepath = MAIN_WHMCS_DIR_.
                        'templates'.DS.
                        'orderforms'.DS.
                        OPO_Configuration_Configuration::$template_name.DS.
                        'configuredomains.tpl';
        
        
        $page = new OPO_PageBuilder_PageBuilder($templatepath);
        
        global $_LANG;
        global $currency;
        global $additionaldomainfields;
        
        
        global $CONFIG;
        
        if (!$currency)
        {
            $currency = getCurrency($_SESSION['uid']);
        }

        $db = new OPO_Database_Database();
        
        $domains = $_SESSION['cart']['domains'];
        
	if (!$domains) 
        {
            $insld = $_GET['sldinput'];
            $intld = $_GET['tldinput'];
            $domains =array(array('type'=>'register','domain'=>$insld.$intld,'regperiod'=>1));
        }
        
        if($domains)
        {
            foreach ($domains as $key => $domainname) 
            {
                $regperiod = $domainname['regperiod'];
                $domainparts = explode(".", $domainname['domain'], 2);
                $sld = $domainparts[0];
                $tld = $domainparts[1];
                
                $data = $db->query('SELECT * FROM tbldomainpricing WHERE extension='.$db->escape("." . $tld))->get();

                $domainconfigsshowing = $eppenabled = false;
                if ($data['dnsmanagement']) {
                        $domainconfigsshowing = true;
                }
                if ($data['emailforwarding']) {
                        $domainconfigsshowing = true;
                }
                if ($data['idprotection']) {
                        $domainconfigsshowing = true;
                }

                $data2 = $db->query('SELECT * FROM tblpricing WHERE type='.$db->escape("domainaddons").' AND currency='.$db->escape($currency['id']).' AND relid=0')->get();
                
                $domaindnsmanagementprice = $data2['msetupfee'] * $regperiod;
                $domainemailforwardingprice = $data2['qsetupfee'] * $regperiod;
                $domainidprotectionprice = $data2['ssetupfee'] * $regperiod;
                $domaindnsmanagementprice = ($domaindnsmanagementprice == "0.00" ? $_LANG['orderfree'] : formatCurrency($domaindnsmanagementprice));
                $domainemailforwardingprice = ($domainemailforwardingprice == "0.00" ? $_LANG['orderfree'] : formatCurrency($domainemailforwardingprice));
                $domainidprotectionprice = ($domainidprotectionprice == "0.00" ? $_LANG['orderfree'] : formatCurrency($domainidprotectionprice));
                if ($data['eppcode'] && $domainname['type'] == "transfer") {
                        $eppenabled = true;
                        $domainconfigsshowing = true;
                }
                $domainfields = array();
                $tempdomainfields = array();
                
                if ($domainname['type'] == "register") {
                        $tempdomainfields = $additionaldomainfields["." . $tld];
                        if ($tempdomainfields) {
                                $domainconfigsshowing = true;
                                foreach ($tempdomainfields as $fieldkey => $value) {
                                        $fieldname = $value['Name'];
                                        if ($value['DisplayName']) {
                                                $fieldname = $value['DisplayName'];
                                        }
                                        $langvar = $value['LangVar'];
                                        if ($_LANG[$langvar]) {
                                                $fieldname = $_LANG[$langvar];
                                        }
                                        $storedvalue = $domainname['fields'][$fieldkey];
                                        if ($storedvalue) {
                                                $value['Default'] = $storedvalue;
                                        }
                                        if ($value['Type'] == "text") {
                                                $input = "<input type=\"text\" size=\"" . $value['Size'] . (((("\" name=\"domainfield[" . $key . "]") . "[") . $fieldkey . "]") . "\" value=\"") . $value['Default'] . "\" />";
                                                if ($value['Required']) {
                                                        $input .= " *";
                                                }
                                        }
                                        else {
                                                if ($value['Type'] == "dropdown") {
                                                        $input = ((("<select name=\"domainfield[" . $key . "]") . "[") . $fieldkey . "]") . "\">";
                                                        $fieldoptions = explode(",", $value['Options']);
                                                        foreach ($fieldoptions as $optionvalue) {
                                                                $opkey = $opvalue = $optionvalue;
                                                                if (strpos($opkey, "|")) {
                                                                        $opkey = explode("|", $opkey, 2);
                                                                        $opvalue = trim($opkey[1]);
                                                                        $opkey = trim($opkey[0]);
                                                                }
                                                                $input .= ("<option value=\"" . $opkey . "\"");
                                                                if ($value['Default'] == $opkey) {
                                                                        $input .= " selected";
                                                                }
                                                                $input .= ">" . $opvalue . "</option>";
                                                        }
                                                        $input .= "</select>";
                                                }
                                                else {
                                                        if ($value['Type'] == "tickbox") {
                                                                $input = (((("<input type=\"checkbox\" name=\"domainfield[" . $key . "]") . "[") . $fieldkey . "]") . "\"");
                                                                if ($value['Default'] == "on") {
                                                                        $input .= " checked";
                                                                }
                                                                $input .= " />";
                                                        }
                                                        else {
                                                                if ($value['Type'] == "radio") {
                                                                        $fieldoptions = explode(",", $value['Options']);
                                                                        $input = "";
                                                                        foreach ($fieldoptions as $optionvalue) {
                                                                                $input .= (((("<input type=\"radio\" name=\"domainfield[" . $key . "]") . "[") . $fieldkey . "]") . "\" value=\"" . $optionvalue . "\"");
                                                                                if ($value['Default'] == $optionvalue) {
                                                                                        $input .= " checked";
                                                                                }
                                                                                $input .= " /> " . $optionvalue . "<br>";
                                                                        }
                                                                }
                                                        }
                                                }
                                        }
                                        if ($value['Description']) {
                                                $input .= " " . $value['Description'];
                                        }
                                        $domainfields[$fieldname] = $input;
                                }
                        }
                }
                $products = $_SESSION['cart']['products'];
                $hashosting = false;
                if ($products) {
                        $product = $products[0]; 
                            if ($product['domain'] == $domainname['domain']) {
                                    $hashosting = true;
                                    continue;
                            }
                }
                if (!$hashosting) {
                        $atleastonenohosting = true;
                }
                $domainsarray[$key] = array("domain" => $domainname['domain'], "regperiod" => $domainname['regperiod'], "dnsmanagement" => $data['dnsmanagement'], "emailforwarding" => $data['emailforwarding'], "idprotection" => $data['idprotection'], "dnsmanagementprice" => $domaindnsmanagementprice, "emailforwardingprice" => $domainemailforwardingprice, "idprotectionprice" => $domainidprotectionprice, "dnsmanagementselected" => $domainname['dnsmanagement'], "emailforwardingselected" => $domainname['emailforwarding'], "idprotectionselected" => $domainname['idprotection'], "eppenabled" => $eppenabled, "eppvalue" => $domainname['eppcode'], "fields" => $domainfields, "configtoshow" => $domainconfigsshowing, "hosting" => $hashosting);
                
            }
        }
        $smartyvalues['domains'] = $domainsarray;
        $smartyvalues['atleastonenohosting'] = $atleastonenohosting;
        if ((!$_SESSION['cart']['ns1']) && !$_SESSION['cart']['ns2']) {
                $i = 1;
                while ($i <= 5) {
                        $_SESSION['cart']["ns" . $i] = $CONFIG["DefaultNameserver" . $i];
                        ++$i;
                }
        }
        $i = 1;
        while ($i <= 5) {
                $smartyvalues["domainns" . $i] = $_SESSION['cart']["ns" . $i];
                ++$i;
        }
        
        $page->LANG                     = $_LANG;
        
        foreach ($smartyvalues as $key=>$value)
        {
            $page->setVar($key, $value);
        }
        
        return $page->build();
    }

    
}