<?php
//if (!defined('WHMCS')) die("This file cannot be accessed directly");   //only WHMCS

require_once dirname(__FILE__).DIRECTORY_SEPARATOR.'start.php';
use Illuminate\Database\Capsule\Manager as Capsule;

// deciding when cart schould be clear and when template schould be changed back to onapageorderform
function onepageorderform_CleintArea($params)
{
    if($_SESSION['OrderFormTemplate'] == 'modern' && empty($_REQUEST) && $params['filename'] == 'cart')
    {
        header('Location: '.'cart.php?carttpl=onepageorderform');
        die();
    }
    if(isset($_POST['clear_button']))
    {
        unset($_SESSION['cart']);
        unset($_SESSION['currency']);
        unset($_POST['clear_button']);
        header("Refresh:0");
        die();
    }
}
add_hook('ClientAreaPage',101,'onepageorderform_CleintArea');

add_hook('ClientAreaPageCart', 1, function($vars) {
    $cprefix = $vars['currency']['prefix'];
    $csuffix = $vars['currency']['suffix'];
    $currency = $vars['currency']['id'];
    $allProducts = new stdClass();

    $productsData = Capsule::select("SELECT * FROM tblproducts LEFT OUTER JOIN tblpricing ON tblproducts.id = tblpricing.relid WHERE tblproducts.hidden='0' AND tblpricing.currency='$currency' AND tblpricing.type='product'");

    foreach ($productsData as $key => $product) {
        if ($product->paytype == 'free')
        {
            $product->price = '';
            $product->billingCycle = 'free';
            $product->testqty = '';
        }elseif ($product->paytype == 'onetime') {
            $price = $cprefix.$product->monthly.$csuffix;
            if($product->msetupfee > 0)
            {
                $price = $price.' + '.$cprefix.$product->msetupfee.$csuffix.' Setup Fee';
            }
            $product->price = $price;
            $product->billingCycle = 'onetime';
            $product->testqty = '';
        }else{
            if($product->monthly > 0)
            {
                $price = $cprefix.$product->monthly.$csuffix;
                if($product->msetupfee > 0)
                {
                    $price = $price.' + '.$cprefix.$product->msetupfee.$csuffix.' Setup Fee';
                }
                $product->price = $price;
                $product->billingCycle = 'monthly';
                $product->testqty = '';
            }elseif ($product->quarterly > 0) {
                $price = $cprefix.$product->quarterly.$csuffix;
                if($product->qsetupfee > 0)
                {
                    $price = $price.' + '.$cprefix.$product->qsetupfee.$csuffix.' Setup Fee';
                }
                $product->price = $price;
                $product->billingCycle = 'quarterly';
                $product->testqty = '';
            }elseif ($product->semiannually > 0) {
                $price = $cprefix.$product->semiannually.$csuffix;
                if($product->ssetupfee > 0)
                {
                    $price = $price.' + '.$cprefix.$product->ssetupfee.$csuffix.' Setup Fee';
                }
                $product->price = $price;
                $product->billingCycle = 'semiannually';
                $product->testqty = '';
            }elseif ($product->annually > 0) {
                $price = $cprefix.$product->annually.$csuffix;
                if($product->asetupfee > 0)
                {
                    $price = $price.' + '.$cprefix.$product->asetupfee.$csuffix.' Setup Fee';
                }
                $product->price = $price;
                $product->billingCycle = 'annually';
                $product->testqty = '';
            }elseif ($product->biennially > 0) {
                $price = $cprefix.$product->biennially.$csuffix;
                if($product->bsetupfee > 0)
                {
                    $price = $price.' + '.$cprefix.$product->bsetupfee.$csuffix.'Setup Fee';
                }
                $product->price = $price;
                $product->billingCycle = 'biennially';
                $product->testqty = '';
            }  else {
                $price = $cprefix.$product->triennially.$csuffix;
                if($product->tsetupfee > 0)
                {
                    $price = $price.' + '.$cprefix.$product->tsetupfee.$csuffix.' Setup Fee';
                }
                $product->price = $price;
                $product->billingCycle = 'triennially';
                $product->testqty = '';
            }
        }
    }
    
    foreach ($productsData as $key => $value) {
        $resultArray[] = (array)$value;
    }
    $allProducts->results = $resultArray;

    return (array)$allProducts;
});

//leaving in cart only last selected product
function onepageorderform_actualizeCart($params)
{   
    onepageorderform_loadAutoloader();
    OPO_Configuration_Configuration::init();
    onepageorderform_loadErrorHandler();
 
    //checking active cart from WHMCS config and session:
    if (trim(OPO_WHMCS_Configuration::get('OrderFormTemplate'))==OPO_Configuration_Configuration::$template_name &&
        (!isset($_SESSION['OrderFormTemplate']) || trim($_SESSION['OrderFormTemplate'])==OPO_Configuration_Configuration::$template_name)
        )
    {
        $sessionbefore = $_SESSION;
        
        OPO_System_Sessionmanagement::reorganizeCart();
        
        $sessionafter = $_SESSION;
        
         //log session information if debug mode is on:
        if (OPO_Configuration_Configuration::$debug_mode)
            logModuleCall(
                    OPO_Configuration_Configuration::$module_name,
                    '',
                    'onepageorderform_actualizeCart',
                    '',
                    'SESSIONBEFORE='.PHP_EOL.
                    print_r($sessionbefore,true).PHP_EOL.
                    'SESSIONAFTER='.PHP_EOL.
                    print_r($sessionafter,true).PHP_EOL
                    );
        
    }
    
    onepageorderform_loadErrorHandler();
    onepageorderform_loadErrorHandler();
}

add_hook('OrderProductPricingOverride',101,'onepageorderform_actualizeCart');
add_hook('OrderAddonPricingOverride',101,'onepageorderform_actualizeCart');
add_hook('OrderDomainPricingOverride',101,'onepageorderform_actualizeCart');




//this is for product-independent loading of allowed register/own domain posibilities:
//(to make possible to load product domain configuration view even if product doesn't need domains)
function onepageorderform_addViewAdditionalInfos()
{
    onepageorderform_loadAutoloader();
    OPO_Configuration_Configuration::init();
    onepageorderform_loadErrorHandler();
    
    $whmcs_config = OPO_WHMCS_Configuration::get();
    
    $head_return = '';
    
    //checking active cart from WHMCS config and session:
    if (trim(OPO_WHMCS_Configuration::get('OrderFormTemplate'))==OPO_Configuration_Configuration::$template_name &&
        (!isset($_SESSION['OrderFormTemplate']) || trim($_SESSION['OrderFormTemplate'])==OPO_Configuration_Configuration::$template_name)
        )
    {
        if (trim($whmcs_config['AllowOwnDomain'])=='on')
        {
            $head_return = 
            '<script type="text/javascript">var mg_onepageorderform_AOD=true;</script>';
        }
        else
        {
            $head_return = 
            '<script type="text/javascript">var mg_onepageorderform_AOD=false;</script>';
        }
    }
    
    onepageorderform_loadErrorHandler();
    onepageorderform_loadErrorHandler();
    
    return $head_return;
}

add_hook("ClientAreaHeadOutput", 101, "onepageorderform_addViewAdditionalInfos");




function onepageorderform_validateCheckout()
{
    onepageorderform_loadAutoloader();
    OPO_Configuration_Configuration::init();
    onepageorderform_loadErrorHandler();
    
    $whmcs_config = OPO_WHMCS_Configuration::get();
    
    global $_LANG;
    
    $errors = array();
    $ok = true;
    
    //checking active cart from WHMCS config and session:
    if (trim(OPO_WHMCS_Configuration::get('OrderFormTemplate'))==OPO_Configuration_Configuration::$template_name &&
        (!isset($_SESSION['OrderFormTemplate']) || trim($_SESSION['OrderFormTemplate'])==OPO_Configuration_Configuration::$template_name)
        )
    {
        //get product id:
        $product_id = $_SESSION['cart']['products'][0]['pid'];
            
        //checking if product require domain:
        $product_need_domain = OPO_WHMCS_Products::get($product_id, 'showdomainoptions')?true:false;
        
        if (!$product_need_domain)
        {
            $_SESSION['cart']['products'][0]['domain'] = '';
        }
        else
        {
            //check if product domain is dummy domain:
            $maindomain = trim($_SESSION['cart']['products'][0]['domain']);
            if ($maindomain == '' || $maindomain == 'thisistestdomainonlyandwontberegistered.test')
            {
                //throwing error:
                $ok = false;
                $errors []= $_LANG['domainerrornodomain'];
            }
        }
    }
    
    onepageorderform_loadErrorHandler();
    onepageorderform_loadErrorHandler();
    if ($ok) return array();
    else if (!empty($errors)) return $errors;
    else return array('Unknown error appear. Please contact admin.');
        
}

add_hook('ShoppingCartValidateCheckout',101,'onepageorderform_validateCheckout');

